import { r as registerInstance, h } from './index-de08edef.js';
var ProfileView = /** @class */ (function () {
    function ProfileView(hostRef) {
        registerInstance(this, hostRef);
    }
    ProfileView.prototype.render = function () {
        var _a = this.profile, name = _a.name, location = _a.location, role = _a.role, imageSrc = _a.imageSrc, homepage = _a.homepage, note = _a.note;
        return h("ion-card", null, h("ion-card-header", null, h("ion-avatar", null, h("img", { src: imageSrc })), h("ion-card-title", null, name), h("ion-card-subtitle", null, role)), h("ion-card-content", null, h("ion-grid", null, h("ion-row", null, h("ion-col", { size: "12", "size-sm": true }, h("ion-icon", { name: "location-outline" }), " ", location), h("ion-col", { size: "12", "size-sm": true }, h("ion-icon", { name: "globe-outline" }), " ", h("a", { href: homepage }, homepage))), h("ion-row", null, h("ion-col", { size: "12", "size-sm": true }, note)))));
    };
    return ProfileView;
}());
export { ProfileView as profile_view };
